DATA_PATH = 'D:\data';

DATASET_NAME = 'Indoor4\ORIG';

for MAG = 6%[5, 6, 7, 8, 10, 12, 16]
for BIN_SIZE = 4%[4, 5, 6, 8, 10, 12, 16];

MAX_SIZE = 300;
COLOR_OPTION = 'Gray';
if (strcmp(COLOR_OPTION, 'Gray'))
    DESCRIPTOR_NAME = fullfile(DATASET_NAME, [num2str(MAG), '_', num2str(BIN_SIZE), ...
        '_', num2str(MAX_SIZE)]);
else
    DESCRIPTOR_NAME = fullfile(DATASET_NAME, [num2str(MAG), '_', num2str(BIN_SIZE), ...
        '_', num2str(MAX_SIZE), '_', COLOR_OPTION(1)]);
end

MAX_IMAGES_PER_CATEGORY = 50;
K_MEANS = 2048;
SEP_CLUSTER = false;
MAX_ITERATIONS = 128;
INIT = 'plusplus';
MAX_IMAGES_PER_CATEGORY_S = 'ALL';
if (MAX_IMAGES_PER_CATEGORY ~= -1)
    MAX_IMAGES_PER_CATEGORY_S = num2str(MAX_IMAGES_PER_CATEGORY);
end
CODEBOOK_NAME = fullfile(DESCRIPTOR_NAME, [MAX_IMAGES_PER_CATEGORY_S, '_', num2str(K_MEANS), '_P~1']);
CODEBOOK_FILENAME = 'codebook.mat';

KNN = 5;
BETA = 1e-4;
LP = -1;
NP = 2;
NORMALIZED = true;
NORMALIZED_S = '_';
if (NORMALIZED)
    NORMALIZED_S = '';
end
PYRAMID = [1, 2, 4];
%ORIENTATION_NAME = fullfile('RAND', DATASET_NAME, [num2str(MAX_SIZE), 'R']);
TRAINING_SAMPLES = 20000;
O_KNN = 1;
ORIENTATION_OPTION = ['Bristol,RSF(4,4),', num2str(TRAINING_SAMPLES), 'S,', num2str(O_KNN), 'NN'];
ORIENTATION_NAME = fullfile('RSF_KNNP', DATASET_NAME, ...
    [num2str(MAG), '_', num2str(BIN_SIZE), '_', num2str(MAX_SIZE)], ORIENTATION_OPTION);

for AZIMUTH_BINS = [1, 2, 4, 8]
for POLAR_BINS = [1, 2, 4]
FEATURE_NAME = fullfile(CODEBOOK_NAME, ORIENTATION_OPTION, [num2str(KNN), ',', num2str(length(PYRAMID)), 'L', ',' ...
    '(', num2str(AZIMUTH_BINS), '_', num2str(POLAR_BINS), ')O', NORMALIZED_S]);

TIMES = 10;
TRAINING_SAMPLES_PER_CATEGORY = 80;
C = [10, 8, 12, 5, 20];
RESULT_FILE_NAME = ['T', num2str(TRAINING_SAMPLES_PER_CATEGORY), '_C'];
RESULT_FILE_EXPANSION = '.txt';
RESULT_NAME = FEATURE_NAME;

DATASET_PATH = fullfile(DATA_PATH, 'datasets', DATASET_NAME);
DESCRIPTOR_PATH = fullfile(DATA_PATH, 'descriptors\RSF', DESCRIPTOR_NAME);
CODEBOOK_PATH = fullfile(DATA_PATH, 'codebooks\RSF', CODEBOOK_NAME);
ORIENTATION_PATH = fullfile(DATA_PATH, 'orientations', ORIENTATION_NAME);
FEATURE_PATH = fullfile(DATA_PATH, 'features\RSF\LLC+OF_KNNP', FEATURE_NAME);
RESULT_PATH = fullfile(DATA_PATH, 'results\RSF\LLC+OF_KNNP', RESULT_NAME);

run(fullfile(DATA_PATH, 'libs', 'vlfeat/toolbox/vl_setup'));

going = true;

if (going)
    DenseSIFT(DATASET_PATH, DESCRIPTOR_PATH, BIN_SIZE, MAG, MAX_SIZE, COLOR_OPTION);
end
if (going)
    going = KMeans(DESCRIPTOR_PATH, CODEBOOK_PATH, CODEBOOK_FILENAME, K_MEANS, SEP_CLUSTER, ...
        MAX_IMAGES_PER_CATEGORY, INIT, MAX_ITERATIONS);
end
FEATURE_NAME_ = fullfile(CODEBOOK_NAME, ORIENTATION_OPTION);
FEATURE_PATH_ = fullfile(DATA_PATH, 'features\RSF\LLC+OF_KNNP', FEATURE_NAME_);
PoolingPatch(DESCRIPTOR_PATH, CODEBOOK_PATH, CODEBOOK_FILENAME, ORIENTATION_PATH, ...
        FEATURE_PATH_, KNN, BETA, LP, NP, NORMALIZED, PYRAMID, [1, 2, 4, 8], [1, 2, 4]);
if (going)
    going = Pooling(DESCRIPTOR_PATH, CODEBOOK_PATH, CODEBOOK_FILENAME, ORIENTATION_PATH, ...
        FEATURE_PATH, KNN, BETA, LP, NP, NORMALIZED, PYRAMID, AZIMUTH_BINS, POLAR_BINS);
end
if (going)
    [accuracy, going] = Classifier(FEATURE_PATH, RESULT_PATH, RESULT_FILE_NAME, ...
        RESULT_FILE_EXPANSION, TIMES, TRAINING_SAMPLES_PER_CATEGORY, C);
end

end
end

end
end
