function [l, d] = LocalColorStatistics(image, binSize, mag)

[width, height, ~] = size(image);
xCount = floor((width - binSize) / mag) + 1;
xStart = floor((width - ((xCount - 1) * mag + binSize)) / 2);
yCount = floor((height - binSize) / mag) + 1;
yStart = floor((height - ((yCount - 1) * mag + binSize)) / 2);
l = zeros(xCount * yCount, 2);
d = zeros(xCount * yCount, 96);
count = 0;
bSize = binSize / 4;
for x = 1: 1: xCount
    for y = 1: 1: yCount
        count = count + 1;
        x0 = (x - 1) * mag + xStart;
        y0 = (y - 1) * mag + yStart;
        l(count, 2) = x0 + binSize / 2;
        l(count, 1) = y0 + binSize / 2;
        count_ = 0;
        for x_ = 1: 1: 4
            for y_ = 1: 1: 4
                x0_ = x0 + (x_ - 1) * bSize;
                y0_ = y0 + (y_ - 1) * bSize;
                vec = image(x0_ + 1: x0_ + bSize, y0_ + 1: y0_ + bSize, :);
                vector = reshape(vec, [bSize * bSize, 3]);
                d(count, count_ * 6 + 1) = mean(vector(:, 1));
                d(count, count_ * 6 + 2) = mean(vector(:, 2));
                d(count, count_ * 6 + 3) = mean(vector(:, 3));
                d(count, count_ * 6 + 4) = std(vector(:, 1));
                d(count, count_ * 6 + 5) = std(vector(:, 2));
                d(count, count_ * 6 + 6) = std(vector(:, 3));
                count_ = count_ + 1;
            end
        end
    end
end

end
