DATA_PATH = 'D:\data';

DATASET_NAME = 'Sport8\ORIG';

for MAG = [8, 10, 12, 16, 20, 24]
for BIN_SIZE = [12, 16, 20, 24, 32, 40]

for MAX_SIZE = 600%[300, 600]
DESCRIPTOR_NAME = fullfile(DATASET_NAME, [num2str(MAG), '_', num2str(BIN_SIZE), ...
    '_', num2str(MAX_SIZE)]);

for PRESERVED_DIMENSIONS = 64%[8, 16, 32, 48, 64, 96]
for MAX_DESCRIPTORS_FOR_TRAINING = 2%[1, 2, 5, -1]

PCOEFFICIENT_NAME = fullfile(DESCRIPTOR_NAME, [num2str(MAX_DESCRIPTORS_FOR_TRAINING), 'T']);
PCOEFFICIENT_FILENAME = 'coefficient.mat';
PDESCRIPTOR_NAME = PCOEFFICIENT_NAME;

for K_GMM = 256%[256, 128, 64, 32, 16]
PYRAMID = [1, 1; 2, 2; 1, 3];
MAX_ITERATIONS = 128;
CODEBOOK_NAME = fullfile(PDESCRIPTOR_NAME, [num2str(PRESERVED_DIMENSIONS), 'D_', ...
    num2str(MAX_DESCRIPTORS_FOR_TRAINING), 'T']);
CODEBOOK_FILE_NAME = 'codebook_';
CODEBOOK_FILE_EXPANSION = '.mat';
FEATURE_NAME = fullfile(CODEBOOK_NAME, [num2str(K_GMM), 'K_', num2str(size(PYRAMID, 1)), 'L']);

TIMES = 10;
TRAINING_SAMPLES_PER_CATEGORY = 70;
SPLIT_NAME = DATASET_NAME;
C = [10, 8, 12, 5, 20];
RESULT_FILE_NAME = ['T', num2str(TRAINING_SAMPLES_PER_CATEGORY), '_C'];
RESULT_FILE_EXPANSION = '.txt';
RESULT_NAME = FEATURE_NAME;

DATASET_PATH = fullfile(DATA_PATH, 'datasets', DATASET_NAME);
DESCRIPTOR_PATH = fullfile(DATA_PATH, 'descriptors\LCS', DESCRIPTOR_NAME);
PCOEFFICIENT_PATH = fullfile(DATA_PATH, 'coefficients\LCS', PCOEFFICIENT_NAME);
PDESCRIPTOR_PATH = fullfile(DATA_PATH, 'descriptors\PLCS', PDESCRIPTOR_NAME);
CODEBOOK_PATH = fullfile(DATA_PATH, 'codebooks\PLCS', CODEBOOK_NAME);
FEATURE_PATH = fullfile(DATA_PATH, 'features\PLCS\FSH', FEATURE_NAME);
SPLIT_PATH = fullfile(DATA_PATH, 'splits\', SPLIT_NAME);
RESULT_PATH = fullfile(DATA_PATH, 'results\PLCS\FSH', RESULT_NAME);

run(fullfile(DATA_PATH, 'libs', 'vlfeat/toolbox/vl_setup'));

going = true;

if (going)
    ExtractLCS(DATASET_PATH, DESCRIPTOR_PATH, BIN_SIZE, MAG, MAX_SIZE);
end
if (going)
    PCA(DESCRIPTOR_PATH, PCOEFFICIENT_PATH, PCOEFFICIENT_FILENAME, PDESCRIPTOR_PATH, MAX_DESCRIPTORS_FOR_TRAINING);
end
if (going)
    going = KGMM(PDESCRIPTOR_PATH, CODEBOOK_PATH, CODEBOOK_FILE_NAME, CODEBOOK_FILE_EXPANSION, ...
        MAX_DESCRIPTORS_FOR_TRAINING, PRESERVED_DIMENSIONS, K_GMM, MAX_ITERATIONS, 1);
end
if (going)
    going = Pooling(PDESCRIPTOR_PATH, CODEBOOK_PATH, CODEBOOK_FILE_NAME, ...
        CODEBOOK_FILE_EXPANSION, FEATURE_PATH, PRESERVED_DIMENSIONS, K_GMM, PYRAMID);
end
if (going)
    [accuracy, going] = Classifier(FEATURE_PATH, SPLIT_PATH, RESULT_PATH, ...
        RESULT_FILE_NAME, RESULT_FILE_EXPANSION, TIMES, TRAINING_SAMPLES_PER_CATEGORY, C);
end

end
end
end
end
end
end
