function AnnotationNormalization(annotationPath)

files = dir(fullfile(annotationPath, '*.mat'));
for i = 1: 1: length(files)
    annotationFile = fullfile(annotationPath, files(i).name);
    annotation = load(annotationFile);
    annotation = annotation.annotation;
    for r = 1: 1: annotation.regions
        vector = annotation.region(r).vector;
        if (vector(1) == 0 && vector(2) == 0 && vector(3) == 0)
            theta = 0;
            phi = 0;
        elseif (vector(1) == 0 && vector(2) == 0)
            theta = 0;
            if (vector(3) > 0)
                phi = pi / 2;
            else
                phi = - pi / 2;
            end
        else
            if (vector(1) > 0 && vector(2) == 0)
                theta = 0;
            elseif (vector(1) < 0 && vector(2) == 0)
                theta = pi;
            elseif (vector(1) == 0 && vector(2) > 0)
                theta = pi / 2;
            elseif (vector(1) == 0 && vector(2) < 0)
                theta = pi / 2 * 3;
            elseif (vector(1) > 0 && vector(2) > 0)
                theta = atan(vector(2) / vector(1));
            elseif (vector(1) < 0 && vector(2) > 0)
                theta = pi - atan( - vector(2) / vector(1));
            elseif (vector(1) < 0 && vector(2) < 0)
                theta = pi + atan(vector(2) / vector(1));
            elseif (vector(1) > 0 && vector(2) < 0)
                theta = pi * 2 - atan( - vector(2) / vector(1));
            end
            phi = asin(vector(3));
        end
        annotation.region(r).theta = theta;
        annotation.region(r).phi = phi;
    end
    save(annotationFile, 'annotation');
end

end
