function FeatureExtraction(imagePath, featurePath, step, binSize)

if (~isdir(featurePath))
    mkdir(featurePath);
end

scale = binSize / step;
files = dir(fullfile(imagePath, '*.png'));
for i = 1: 1: length(files)
    [~, name] = fileparts(files(i).name);
    imageFile = fullfile(imagePath, [name, '.png']);
    featureFile = fullfile(featurePath, [name, '.mat']);
    if (~exist(featureFile, 'file'))
        image = imread(imageFile);
        image = rgb2gray(image);
        %image = image(:, :, 1) * 0.2989 + image(:, :, 2) * 0.5870 + image(:, :, 3) * 0.1140;
        image = single(image);
        [feature.height, feature.width] = size(image);
        [feature.SIFT.l, feature.SIFT.d] = vl_dsift(vl_imsmooth( ...
            image, sqrt(max(scale .^ 2 - 0.25, 0))), 'size', binSize, 'step', step, 'floatdescriptors');
        for l = 1: 1: size(feature.SIFT.l, 2)
            ss = sum(feature.SIFT.d(:, l));
            if (ss > 0)
                feature.SIFT.d(:, l) = feature.SIFT.d(:, l) / ss;
                feature.SIFT.d(:, l) = feature.SIFT.d(:, l) .^ (1 / 2);
                feature.SIFT.d(:, l) = feature.SIFT.d(:, l) * 512;
            end
        end
        save(featureFile, 'feature');
    end
    fprintf('Finished processing %s. \n', imageFile);
end

end
