DATA_PATH = 'D:\data';
TRAINING_DATA = 'Training';
TESTING_DATA = 'Testing';

%{
IMAGE_NAME = 'Truth2013-01-01__10-53-14_0008';
IMAGE_FILE = fullfile(TRAINING_DATA, [IMAGE_NAME, '_ColourImage.bmp']);
ANNOTATION_FILE = fullfile(TRAINING_DATA, [IMAGE_NAME, '.tr']);
ShowSample(IMAGE_FILE, ANNOTATION_FILE);
%}

%{
TRAINING_DATA_ = 'Training_';
TESTING_DATA_ = 'Testing_';
DataWashing(TRAINING_DATA, TRAINING_DATA_);
DataWashing(TESTING_DATA, TESTING_DATA_);
%}

DATASET_NAME = 'Bristol';

STEP_SIZE = 4;
WINDOW_SIZE = 4;
FEATURE_NAME = fullfile(DATASET_NAME, ['RSF(', num2str(STEP_SIZE), ',', num2str(WINDOW_SIZE), ')']);

TRAINING_SAMPLES = 20000;
MODEL_NAME = fullfile(FEATURE_NAME, [num2str(TRAINING_SAMPLES), 'PS']);

for KNN = [0, 1, 5, 10, 20, 50, 100, 200, 500, 1000]

RESULT_NAME = fullfile(MODEL_NAME, [num2str(KNN), 'NN', '_AVG']);

IMAGE_PATH_TRAINING = fullfile(DATA_PATH, 'datasets', DATASET_NAME, TRAINING_DATA);
IMAGE_PATH_TESTING = fullfile(DATA_PATH, 'datasets', DATASET_NAME, TESTING_DATA);
ANNOTATION_PATH_TRAINING = fullfile(DATA_PATH, 'annotations', DATASET_NAME, TRAINING_DATA);
ANNOTATION_PATH_TESTING = fullfile(DATA_PATH, 'annotations', DATASET_NAME, TESTING_DATA);
FEATURE_PATH_TRAINING = fullfile(DATA_PATH, 'ofeatures\RSF', FEATURE_NAME, TRAINING_DATA);
FEATURE_PATH_TESTING = fullfile(DATA_PATH, 'ofeatures\RSF', FEATURE_NAME, TESTING_DATA);
MODEL_PATH = fullfile(DATA_PATH, 'omodels\RSF_KNN', MODEL_NAME);
MODEL_FILENAME = 'model.mat';
RESULT_PATH = fullfile(DATA_PATH, 'oresults\RSF_KNN', RESULT_NAME);

run(fullfile(DATA_PATH, 'libs', 'vlfeat/toolbox/vl_setup'));
%FeatureExtraction(IMAGE_PATH_TRAINING, FEATURE_PATH_TRAINING, STEP_SIZE, WINDOW_SIZE);
%FeatureExtraction(IMAGE_PATH_TESTING, FEATURE_PATH_TESTING, STEP_SIZE, WINDOW_SIZE);

%ModelTraining(ANNOTATION_PATH_TRAINING, FEATURE_PATH_TRAINING, MODEL_PATH, MODEL_FILENAME, WINDOW_SIZE, TRAINING_SAMPLES);
ModelTesting(ANNOTATION_PATH_TESTING, FEATURE_PATH_TESTING, MODEL_PATH, MODEL_FILENAME, RESULT_PATH, WINDOW_SIZE, KNN);

end
