function [image, annotation] = ShowSample(imageFile, annotationFile)

image = imread(imageFile, 'bmp');
annotation = [];
input = fopen(annotationFile, 'r');
str = fgetl(input);
index1 = strfind(str, '=');
annotation.regions = str2double(str(index1 + 2: length(str)));
str = fgetl(input);
index1 = strfind(str, '=');
annotation.points = str2double(str(index1 + 2: length(str)));
str = fgetl(input);
index1 = strfind(str, '=');
annotation.edges = str2double(str(index1 + 2: length(str)));
str = fgetl(input);
index1 = strfind(str, '=');
annotation.height = str2double(str(index1 + 2: length(str)));
str = fgetl(input);
index1 = strfind(str, '=');
annotation.width = str2double(str(index1 + 2: length(str)));
fgetl(input);
fgetl(input);
annotation.point = zeros(annotation.points, 2);
annotation.edge = zeros(annotation.edges, 2);
while (true)
    str = fgetl(input);
    index1 = strfind(str, '=');
    index2 = strfind(str, ',');
    if (isempty(index2))
        break;
    end
    ID = str2double(str(index1 + 2: index2(1) - 3));
    num1 = str2double(str(index2(1) + 2: index2(2) - 2));
    num2 = str2double(str(index2(2) + 2: length(str)));
    if (strfind(str, 'Point') > 0)
        annotation.point(ID + 1, 1) = num1 + 1;
        annotation.point(ID + 1, 2) = num2 + 1;
    elseif (strfind(str, 'Edge') > 0)
        annotation.edge(ID + 1, 1) = num1 + 1;
        annotation.edge(ID + 1, 2) = num2 + 1;
    else
        break;
    end
end
for r = 1: 1: annotation.regions
    str = fgetl(input);
    index1 = strfind(str, ':');
    index2 = strfind(str, ',');
    annotation.region(r).points = length(index2) + 1;
    annotation.region(r).point = zeros(1, annotation.region(r).points);
    for p = 1: 1: annotation.region(r).points
        if (p == 1)
            annotation.region(r).point(p) = str2double(str(index1(2) + 1: index2(1) - 1));
        elseif (p == annotation.region(r).points)
            annotation.region(r).point(p) = str2double(str(index2(p - 1) + 2: length(str)));
        else
            annotation.region(r).point(p) = str2double(str(index2(p - 1) + 2: index2(p) - 1));
        end
        annotation.region(r).point(p) = annotation.region(r).point(p) + 1;
    end
    fgetl(input);
    fgetl(input);
    fgetl(input);
    str = fgetl(input);
    index1 = strfind(str, ':');
    index2 = strfind(str, ',');
    annotation.region(r).vector = zeros(1, 3);
    annotation.region(r).vector(1) = str2double(str(index1(2) + 1: index2(1) - 1));
    annotation.region(r).vector(2) = str2double(str(index2(1) + 2: index2(2) - 2));
    annotation.region(r).vector(3) = str2double(str(index2(2) + 2: length(str)));
    annotation.region(r).plane = (annotation.region(r).vector(1) == 0 && ...
        annotation.region(r).vector(2) == 0 && annotation.region(r).vector(3) == 0);
end
fclose(input);

annotation.map = zeros(annotation.height, annotation.width);
for r = 1: 1: annotation.regions
    coor = zeros(annotation.region(r).points, 2);
    for p = 1: 1: annotation.region(r).points
        coor(p, :) = annotation.point(annotation.region(r).point(p), :);
    end
    for x = 1: 1: annotation.width
        for y = 1: 1: annotation.height
            in = inpolygon(x, y, coor(:, 1), coor(:, 2));
            if (in)
                annotation.map(y, x) = r;
            end
        end
    end
end


%imshow(image);
%{
h = figure(1);
plot([1, 1], [100, 100]);
saveas(h, 'temp', 'bmp');
%}

% segmentation visualization
%{
for p = 1: 1: annotation.points
    x = annotation.point(p, 1);
    y = annotation.point(p, 2);
    if (x ~= 0 && y ~= 0)
        for a = x - 1: 1: x + 1
            for b = y - 1: 1: y + 1
                if (a > 0 && a <= annotation.width && b > 0 && b <= annotation.height)
                    image(b, a, 1) = 255;
                    image(b, a, 2) = 0;
                    image(b, a, 3) = 0;
                end
            end
        end
    end
end
for r = 1: 1: annotation.regions
    coor = zeros(annotation.region(r).points, 2);
    for p = 1: 1: annotation.region(r).points
        coor(p, :) = annotation.point(annotation.region(r).point(p), :);
    end
    for x = 1: 1: annotation.width
        for y = 1: 1: annotation.height
            in = inpolygon(x, y, coor(:, 1), coor(:, 2));
            if (in)
                image(y, x, 1) = 0;
                image(y, x, 1) = 255;
                image(y, x, 1) = 0;
            end
        end
    end
    imwrite(image, ['temp', num2str(r) '.png'], 'png');
end
%}

end
